var fs = require('fs');
var cheerio = require('cheerio');
var url = require('url');

var urls = [];

module.exports = {
    hooks: {
        "page": function (page) {

            if (this.output.name != 'website') return page;

            var outputUrl = this.output.toURL('_book/' + page.path);

            urls.push({
                url: outputUrl + (outputUrl.substr(-5, 5) !== '.html' ? 'index.html' : '')
            });

            return page;

        },

        "finish": function() {
            var $, $el, html;
            var pathFile = this.options.pluginsConfig && this.options.pluginsConfig.layout && this.options.pluginsConfig.layout.headerPath;
            var tmpl = '';

            if (pathFile && fs.existsSync(pathFile)) tmpl = fs.readFileSync(pathFile, {encoding: 'utf-8'});

            urls.forEach(item => {
                html = fs.readFileSync(item.url, {encoding: 'utf-8'});
                $ = cheerio.load(html);
                $el = $('body .book');

                $el.prepend(tmpl);

                fs.writeFileSync(item.url, $.root().html(), {encoding: 'utf-8'});
            })
        }
    }
}
